*Ŀ 
*                                                                            
* -------------------------------                                            
* ***********  DBSCAN  **********                                             
* -------------------------------                                            
*                                                                           
* DBSCAN 1.0      december, 90, calls tu UFD's                              
* DBSCAN 1.2  12. december, 90, switched to VMM memory handler              
* DBSCAN 2.0   3. january,  91, invented M.P.S. calls to CODE BLOCKS        
*                                                                           
* Why DBSCAN ?                                                              
*                                                                           
*  If you want to do a text search accross a DBF-file, LOCATE is not        
*  fast enough. If you work with SEEK, you have to carry these index        
*  files. DBSCAN will reduce the search time by 50 % to 80 %.               
*                                                                           
*  What ASCAN(tm) does for Arrays, DBSCAN will do for the dbf-files.        
*                                                                           
*  Syntax:                                                                  
*                              <expB1>                                      
*                             /       \                                     
* <expN1> := DBSCAN( <expC1>,[ M.P.S.  [, <expN1> [, <expN3> )              
*                             \       /                                     
*                              <expC2>              M.P.S. MultiPurposeSlot 
*                                                                           
* <expN1>              returns the recno                                    
* <expC1>              search string                                        
* <expB1> or <expC2>   code block or cUDF.                                  
* <expN2>              nStart, start search here                            
* <expN3>              nCount, search nCount records                        
*                                                                           
* ------------------------------------------------------------------------- 
*  Use these formats for the code blocks & the c Udf.                       
*   {|nRecno, nFieldno| my expration..,nBack }                              
*  or                                                                       
*   My_Udf( nRecno, nFieldno )                                              
*    ...                                                                    
*   RETURN nBack                                                            
*                                                                           
*  Via nBack you can drive DBSCAN. The registered version will tell you how 
*  to adjust these driving parms.<g> Also, the last parameter <expN3> is    
*  recognized yet. The demo is limited to 5 minutes before it returns to DOS
*  without notice!                                                          
* ------------------------------------------------------------------------- 
*                                                                           
* Note:                                                                     
*  - In case of a match, DBSCAN will automaticly pass the coresponding      
*    recno & fieldno to the code block or to the cUDF.                      
*  - DBSCAN will operate with the alias()->operator.                        
*  - DBSCAN has full NETWORK support.                                       
*  - DBSCAN has a dynamic memory handler.          ( uses VMM only !! )     
*  - DBSCAN has MPS. It will detect the perence of a code block or UDF.     
*                                                                           
* Compile:  CLIPPER scandemo /n                                             
* Link...:  RTLINK fi scandemo, dbscan_d                                    
*                                                                           
* Thanks to Uwe Holz, RISC GmbH, Berlin.-inspiration at Colgne DEVCON-      
* Thanks to John T. Opincar, Canada, for sharing thoughts!                  
* ------------------------------------------------------------------------- 
*                                                                           
*  4/01/91 - Minor changes to demo code.  A pause here, a reccount there..  
*            C Pritchard, Paradigm Software                                 
*                                                                           
* In case you want to register: 45.00 U$ for the current release.           
*                                                                           
* Send check or "green stamps" to:                                                                                                                 
* _job-soft_                                                                
* Claustorwall 23                                                           
* W-3380 Goslar 1, Germany                                                  
* Phone: 011-495-(321)-4457, FAX : (Soon, Daam Bundsepost.!)                                         
*                                                                           
* Copyright (c) 1991, _job-soft_, Jobst Hensiek, Germany                    
*

PROCEDURE main

     *****
     *
     * Always declare your vars.
     *
     **
     local nI := 0, nfound[ 51 ], nRec[ 51 ], nCnt := 1, cC := "",;
     cYn :="Y", GeTlIsT := {}, nDumm := 0, nStart := 0, nBack := 1

     static nIncr := 0                         

     ****************************
     *
     *  You should take advantage of code blocks whenever possible.
     *  Imagine you coud load them from disk and compile them with
     *  the macro opereator &! You can adjust blocks to all your
     *  needs from the outside!
     *
     ************

     local b1Block := { | nReco, nField | DevPos(3, 5 + (++nIncr)),;
       DevOut(""), DevPos(4,5), DevOut( iif( nReco > 0,"Recno #:"+;
       STR( nReco,5,0)+" Fieldno #:"+Str( nField, 3)+".","")),;
       nRec[ nIncr ] := nField, 1 }

     local b2Block := { | nReco, nField | _My_UDF( nReco, nField),;
       nRec[ nCnt] := nField, (nBack := 1) }

     Clear
     @ 5,20 SaY       "Ŀ"
     @ RoW()+1,20 sAy "                                        "      
     @ rOw()+1,20 SaY "               Note:                    "
     @ RoW()+1,20 sAy "                                        "      
     @ rOw()+1,20 SaY "    This demo requires approximately    "
     @ RoW()+1,20 sAy "    200K of diskspace to run.           "      
     @ rOw()+1,20 SaY "                                        "
     @ RoW()+1,20 sAy "    Do you want to continue (Y/N)?      "      
     @ rOw()+1,20 SaY "                                        "
     @ ROW()+1,20 SAY ""

     @ ROW()-2,56 GET cYn PICTURE "!" VALID cYn$"YN"
     READ                      

     IF cYn != "Y" .OR. lastkey() == 27
      CLEAR ; QUIT
     ENDIF

*-- { EXPAND DBFSCAN.DBF }----------------------

    USE DBFDEMO NEW
    IF lastrec() < 75
      EXPAND_DBF()                           // found with subntx2 for {SKIP}
    ENDIF
    Clear
    @  1, 1 SAY "Test-DBF is open (135 kb), [PRESS a KEY] to start search for Mike..."
    cC := inkey(0)
    @  3,1 SAY "go >|" +replicate("",50)+"|< done"

*-- { Here DBSCAN uses a code block }------------------------

    * plug a Code Block in
    while ( nI >= 0 )
     nFound[ nCnt++ ] := (nI := ((ALIAS())->(DBSCAN("Mike", b1Block,  ++nI )))) 
    END

*   plug a in a cUDF ...
*   while ( nI >= 0 )
*     nFound[ nCnt++ ] := (nI := DBSCAN("Mike","_MY_UDF", ++nI, 2000 ))
*   END


*-- { DISPLAY ....  }---------------------------
    --nCnt
    @ 4,5 say replicate(" ",60)
    //  The following two lines where changed on 4/1/91 to add the press
    //  any key message and record count!
    @ 5,2 say Str( --nCnt ,2 )+ " entries found out of " + ;
          LTRIM(STR(LASTREC())) + " records."
    @ 7,2 SAY "-- Press any key when ready -- "
    cC := inkey(0)

    USE

    ? " "; ? " Here are Mike's Record/Fieldno's..."; ? ""
    for nI := 1 to nCnt
     QOut(  "R:"+str( nFound[ nI ],5) +   " F:" +str( nRec[ ni++ ],2) ) 
     QQOut( " | R:"+str( nFound[ nI ],5) + " F:" +str( nRec[ ni++ ],2) )
     QQOut( " | R:"+str( nFound[ nI ],5) + " F:" +str( nRec[ ni++ ],2) )
     QQOut( " | R:"+str( nFound[ nI ],5) + " F:" +str( nRec[ ni++ ],2) )
     QQOut( " | R:"+str( nFound[ nI ],5) + " F:" +str( nRec[ ni   ],2) )   
    NEXT


RETURN 

************************
*
*  Will expand the database.
*  Thanks to {Skip}. <g>
*
*************

FUNCTION EXPAND_DBF
    LOCAL nJ := 0
    ? " STAND BY WHILE EXPANDING DBFDEMO.DBF...."
    COPY TO SUBTMP
    FOR nJ := 1 to 49
        APPEND FROM SUBTMP
    NEXT
    ERASE SUBTMP.DBF
    REPLACE ALL DBFDEMO->REC WITH DBFDEMO->(RECNO())
    COMMIT
RETURN NIL




***************************************
*
*  This UDF:_MY_UDF  gets called from within DBSCAN.
*
*  In case of a successfull scan:
*  - nReco  : holds the current record
*  - nField : points to field where the match was found
*  
*  Return codes to DBSCAN()
*   No yet.
*  
*  
***************

FUNCTION _MY_UDF ( nReco, nField )
   //
   // DBSCAN() stuffs nReco & nField

   static snIncr := 0                    // - counter
   local  sBlock                         // - code-block to do the display

   // Hey, make it a Code-Block for speed ...
   sBlock := { | nReco, nField | DevPos(3, 5 + (++snIncr)),;
   DevOut(""), DevPos(4,5), DevOut( iif( nReco > 0,;
   "Recno #:"+STR( nReco,5,0)+" Fieldno #:"+Str( nField, 3)+".",""))}

   EVAL( sBlock, nReco, nField )

RETURN 1                                 // continue






































